10     DIM File$[9],Inp_char$[30],Err_mes$[50],Extension$[9],Command$[9]
20     INTEGER Content,Err_no
30     CLEAR SCREEN
40     IF SYSTEM$("SYSTEM ID")="HP4294A" THEN 
50       ASSIGN @Hp4294a TO 800
60     ELSE
70       ASSIGN @Hp4294a TO 717
80     END IF
90     !
100    OUTPUT @Hp4294a;"STOD FLASH"
110    CALL Inp_file_name(File$)
120    !
130    ON ERROR GOTO Data_select
140 Data_select: !
150    PRINT "Select Saved Content"
160    PRINT " 1: State and Data"
170    PRINT " 2: Data (Binary file)"
180    PRINT " 3: Data (ASCII file)"
190    PRINT " 4: LCD Image"
200    INPUT "Input 1 to 4",Inp_char$
210    Content=IVAL(Inp_char$,10)
220    IF Content<1 OR Content>4 THEN Inp_start
230    OFF ERROR
240    !
250    SELECT Content
260      CASE 1
270        Extension$=".STA"
280        Command$="SAVDSTA"
290      CASE 2
300        PRINT "Select Data Content"
310        Select_array(@Hp4294a,"DATA TRACE","SAVDTRC")
320        Select_array(@Hp4294a,"MEMORY TRACE","SAVMTRC")
330        Select_array(@Hp4294a,"DATA","SAVDAT")
340        Select_array(@Hp4294a,"MEMORY","SAVMEM")
350        Select_array(@Hp4294a,"CAL & COMP DATA","SAVCAL")
360        Extension$=".DAT"
370        Command$="SAVDDAT"
380      CASE 3
390        PRINT "Select Data Content"
400        Select_array(@Hp4294a,"DATA TRACE","SAVDTRC")
410        Select_array(@Hp4294a,"MEMORY TRACE","SAVMTRC")
420        Select_array(@Hp4294a,"DATA","SAVDAT")
430        Select_array(@Hp4294a,"MEMORY","SAVMEM")
440        Select_array(@Hp4294a,"CAL & COMP DATA","SAVCAL")
450        Extension$=".TXT"
460        Command$="SAVDASC"
470      CASE 4
480        Extension$=".TIF"
490        Command$="SAVDTIF"
500    END SELECT
510    !
520 Save_file: !
530    OUTPUT @Hp4294a;"*CLS"
540    OUTPUT @Hp4294a;Command$&" """&File$&""""
550    OUTPUT @Hp4294a;"OUTPERRO?"
560    ENTER @Hp4294a;Err_no,Err_mes$
570    IF Err_no=(-257) THEN 
580      PRINT "Error: "&Err_mes$
590      PRINT "[C]hange File Name / [P]urge File / [E]nd"
600      INPUT "Input C or P or E",Inp_char$
610      IF UPC$(Inp_char$)="C" THEN 
620        CALL Inp_file_name(File$)
630        GOTO Save_file
640      END IF
650      IF UPC$(Inp_char$)="P" THEN 
660        OUTPUT @Hp4294a;"PURG """&File$&Extension$&""""
670        GOTO Save_file
680      END IF
690      PRINT "Save NOT Complete"
700    ELSE
710      PRINT "Save Complete"
720      PRINT "  Save File Name: "&File$&Extension$
730    END IF
740    !
750    END
760    !
770    ! File Name Input Function
780    !
790  SUB Inp_file_name(Inp_name$)
800    DIM Inp_char$[30]
810    ON ERROR GOTO Inp_start
820 Inp_start: !
830    PRINT "Input Save File Name (without Extension)"
840    INPUT "Name?",Inp_char$
850    Inp_name$=UPC$(Inp_char$)
860    IF LEN(Inp_name$)>8 THEN Inp_start
870    PRINT "Input Name: "&Inp_name$
880    INPUT "OK? [Y/N]",Inp_char$
890    IF UPC$(Inp_char$)<>"Y" THEN Inp_start
900    OFF ERROR 
910  SUBEND
920    !
930    ! Save Array Select Function
940    !
950  SUB Select_array(@Hp4294a,Array_name$,Com$)
960    DIM Inp_char$[9]
970    PRINT " Save "&Array_name$&" Array?"
980    INPUT "[Y]es or [N]o? Input [Y/N]",Inp_char$
990    IF UPC$(Inp_char$)="Y" THEN 
1000     OUTPUT @Hp4294a;Com$&" ON"
1010   ELSE
1020     OUTPUT @Hp4294a;Com$&" OFF"
1030   END IF
1040 SUBEND
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent 4294A Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      4/26/1999
5050   !* PROGRAM NAME: file_sav.bas
5060   !* REVISION:     A.01.00
5070   !*
5080   !*    Copyright (c) 1999 Agilent Technologies,
5090   !*             All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
5430   !*************************************************
