10    DIM Adapter$[9],Meas_para$[5],Swp_type$[9]
20    DIM Fmt_a$[9],Fmt_b$[9],Start$[9],Stop$[9],Nop$[5],Osc$[9]
30    DIM Bias$[9],Bw$[5],Avg$[5],Header$[9],Buff$[9]
40    INTEGER Max_chan,Point(4),Scode,I,J,Opc
50    CLEAR SCREEN
60    !
70    IF SYSTEM$("SYSTEM ID")="HP4294A" THEN
80      ASSIGN @Agt4294a TO 800
90      ASSIGN @Binary TO 800;FORMAT OFF
100     ASSIGN @Agt3499a TO 809
110     Scode=8
120   ELSE
130     ASSIGN @Agt4294a TO 717
140     ASSIGN @Binary TO 717;FORMAT OFF
150     ASSIGN @Agt3499a TO 709
160     Scode=7
170   END IF
180   !
190   !    Start      Stop       NOP    OSC     BIAS  BW    AVG
200   DATA "100KHZ" , "200KHZ" , "21" , "0.5" , "0" , "2" , "1"
210   DATA "100KHZ" , "200KHZ" , "21" , "0.5" , "0" , "2" , "1"
220   DATA "100KHZ" , "500KHZ" , "81" , "0.5" , "0" , "2" , "1"
230   DATA "500KHZ" , "600KHZ" , "21" , "0.5" , "0" , "2" , "1"
240   !
250   Max_chan=3
260   Adapter$="M2"
270   Meas_para$="IMPH"
280   Swp_type$="LIST"
290   Pow_mod$="VOLT"
300   Dc_mod$="VOLT"
310   !
320   ! 3499A Setting
330   !
340   OUTPUT @Agt3499a;"SYSMODE HP3488A"
350   OUTPUT @Agt3499a;"RESET"
360   OUTPUT @Agt3499a;"CPAIR 1,2"
370   OUTPUT @Agt3499a;"CLOSE 100,110"
380   !
390   ! Adapter Setup
400   !
410   CLEAR SCREEN
420   OUTPUT @Agt4294a;"PRES"
430   OUTPUT @Agt4294a;"ESNB 256"
440   OUTPUT @Agt4294a;"*SRE 4"
450   OUTPUT @Agt4294a;"E4TP "&Adapter$
460   PRINT "##### Adapter Setup #####"
470   PRINT "Channel 0 is activated."
480   Result=FNSetup_4tp(@Agt4294a,Scode,"Open")
490   IF Result<>0 THEN Prog_end
500   OUTPUT @Agt4294a;"ECALDON"
510   !
520   ! 4294A Setting
530   !
540   OUTPUT @Agt4294a;"MEAS "&Meas_para$
550   OUTPUT @Agt4294a;"POWMOD "&Pow_mod$
560   OUTPUT @Agt4294a;"DCMOD "&Dc_mod$
570   OUTPUT @Agt4294a;"EDITLIST"
580   Point(0)=0
590   FOR I=0 TO Max_chan
600     READ Start$,Stop$,Nop$,Osc$,Bias$,Bw$,Avg$
610     Point(I+1)=Point(I)+IVAL(Nop$,10)
620     OUTPUT @Agt4294a;"SADD"
630     OUTPUT @Agt4294a;"MEAS "&Meas_para$
640     OUTPUT @Agt4294a;"STAR "&Start$
650     OUTPUT @Agt4294a;"STOP "&Stop$
660     OUTPUT @Agt4294a;"POIN "&Nop$
670     OUTPUT @Agt4294a;"BWFACT "&Bw$
680     OUTPUT @Agt4294a;"POWE "&Osc$
690     OUTPUT @Agt4294a;"DCV "&Bias$
700     OUTPUT @Agt4294a;"PAVERFACT "&Avg$
710     OUTPUT @Agt4294a;"SDON"
720   NEXT I
730   OUTPUT @Agt4294a;"EDITDONE"
740   OUTPUT @Agt4294a;"SWPT "&Swp_type$
750   !
760   ! Compensation
770   !
780   ALLOCATE Open(1:Point(Max_chan+1),1:2),Short(1:Point(Max_chan+1),1:2)
790   ALLOCATE Load(1:Point(Max_chan+1),1:2),Temp(1:Point(Max_chan+1),1:2)
800   OUTPUT @Agt4294a;"FORM3"
810   OUTPUT @Agt4294a;"CALP USER"
820   CLEAR SCREEN
830   PRINT "##### Open Compensation #####"
840   FOR I=0 TO Max_chan
850     OUTPUT @Agt3499a;"CLOSE 10"&VAL$(I)&",11"&VAL$(I)
860     PRINT "Channel "&VAL$(I)&" is activated."
870     Result=FNFixt_comp(@Agt4294a,Scode,"Open")
880     IF Result<>0 THEN Prog_end
890     OUTPUT @Agt4294a;"OUTPCOMC1?"
900     ENTER @Agt4294a USING "#,8A";Header$
910     ENTER @Binary;Temp(*)
920     ENTER @Agt4294a USING "#,1A";Buff$
930     FOR J=Point(I)+1 TO Point(I+1)
940       Open(J,1)=Temp(J,1)
950       Open(J,2)=Temp(J,2)
960     NEXT J
970     PRINT
980   NEXT I
990   CLEAR SCREEN
1000  PRINT "##### Short Compensation #####"
1010  FOR I=0 TO Max_chan
1020    OUTPUT @Agt3499a;"CLOSE 10"&VAL$(I)&",11"&VAL$(I)
1030    PRINT "Channel "&VAL$(I)&" is activated."
1040    Result=FNFixt_comp(@Agt4294a,Scode,"Short")
1050    IF Result<>0 THEN Prog_end
1060    OUTPUT @Agt4294a;"OUTPCOMC2?"
1070    ENTER @Agt4294a USING "#,8A";Header$
1080    ENTER @Binary;Temp(*)
1090    ENTER @Agt4294a USING "#,1A";Buff$
1100    FOR J=Point(I)+1 TO Point(I+1)
1110      Short(J,1)=Temp(J,1)
1120      Short(J,2)=Temp(J,2)
1130    NEXT J
1140    PRINT
1150  NEXT I
1160  CLEAR SCREEN
1170  PRINT "##### Load Compensation #####"
1180  OUTPUT @Agt4294a;"DCOMLOADR 100OHM"
1190  OUTPUT @Agt4294a;"DCOMLOADL 0H"
1200  FOR I=0 TO Max_chan
1210    OUTPUT @Agt3499a;"CLOSE 10"&VAL$(I)&",11"&VAL$(I)
1220    PRINT "Channel "&VAL$(I)&" is activated."
1230    Result=FNFixt_comp(@Agt4294a,Scode,"Load")
1240    IF Result<>0 THEN Prog_end
1250    OUTPUT @Agt4294a;"OUTPCOMC3?"
1260    ENTER @Agt4294a USING "#,8A";Header$
1270    ENTER @Binary;Temp(*)
1280    ENTER @Agt4294a USING "#,1A";Buff$
1290    FOR J=Point(I)+1 TO Point(I+1)
1300      Load(J,1)=Temp(J,1)
1310      Load(J,2)=Temp(J,2)
1320    NEXT J
1330    PRINT
1340  NEXT I
1350  !
1360  ! Make new compensation coefficients
1370  !
1380  OUTPUT @Agt4294a;"INPUCOMC1 "&Header$;
1390  OUTPUT @Binary;Open(*),END
1400  OUTPUT @Agt4294a;"INPUCOMC2 "&Header$;
1410  OUTPUT @Binary;Short(*),END
1420  OUTPUT @Agt4294a;"INPUCOMC3 "&Header$;
1430  OUTPUT @Binary;Load(*),END
1440  !
1450  ! Trigger Setting
1460  !
1470  OUTPUT @Agt4294a;"TRGS INT"
1480  OUTPUT @Agt4294a;"HOLD"
1490  !
1500  ! SRQ Setting
1510  !
1520  OUTPUT @Agt4294a;"ESNB 1"
1530  OUTPUT @Agt4294a;"*SRE 4"
1540  !
1550  ! Measuring DUT
1560  !
1570  CLEAR SCREEN
1580  PRINT "##### DUT Measurement #####"
1590  ON ERROR GOTO Dut_meas_start
1600 Dut_meas_start: !
1610  PRINT "Set DUTs for All Channels."
1620  INPUT "OK? [Y/N]",Buff$
1630  OFF ERROR
1640  IF UPC$(Buff$)<>"Y" THEN
1650    PRINT "Program Interruption"
1660    GOTO Prog_end
1670  END IF
1680  OUTPUT @Agt4294a;"MANS ON"
1690  FOR I=0 TO Max_chan
1700    OUTPUT @Agt3499a;"CLOSE 10"&VAL$(I)&",11"&VAL$(I)
1710    WAIT .2
1720    OUTPUT @Agt4294a;"*CLS"
1730    OUTPUT @Agt4294a;"*OPC?"
1740    ENTER @Agt4294a;Opc
1750    ON INTR 7 GOTO Sweep_end
1760    ENABLE INTR 7;2
1770    OUTPUT @Agt4294a;"MANR "&VAL$(Point(I)+1)&","&VAL$(Point(I+1))
1780    OUTPUT @Agt4294a;"SING"
1790    PRINT "Measuring Channel ";VAL$(I)
1800 Sweep_wait: GOTO Sweep_wait
1810 Sweep_end: OFF INTR 7
1820  NEXT I
1830  OUTPUT @Agt3499a;"RESET"
1840  !
1850  PRINT "Measurement Completed"
1860  !
1870 Prog_end: !
1880  END
1890  !
1900  ! Fixture Compensation Data Measurement Function
1910  !
1920  DEF FNFixt_comp(@Agt4294a,INTEGER Scode,Standard$)
1930    DIM Inp_char$[9]
1940    OUTPUT @Agt4294a;"*CLS"
1950    ON ERROR GOTO Conpen_start
1960 Compen_start:   !
1970    PRINT "Set "&Standard$&"-Connection"
1980    INPUT "OK? [Y/N]",Inp_char$
1990    OFF ERROR
2000    IF UPC$(Inp_char$)="Y" THEN
2010      ON INTR Scode GOTO Meas_end
2020      ENABLE INTR Scode;2
2030      SELECT Standard$
2040        CASE "Open"
2050          OUTPUT @Agt4294a;"COMA"
2060        CASE "Short"
2070          OUTPUT @Agt4294a;"COMB"
2080        CASE "Load"
2090          OUTPUT @Agt4294a;"COMC"
2100      END SELECT
2110      PRINT "Now measuring..."
2120 Meas_wait: GOTO Meas_wait
2130 Meas_end: !
2140      PRINT Standard$&" Data Measurement Complete"
2150      RETURN 0
2160    ELSE
2170      PRINT "Program Interruption"
2180      RETURN -1
2190    END IF
2200  FNEND
2210  !
2220  ! 4TP Setup Function
2230  !
2240  DEF FNSetup_4tp(@Agt4294a,INTEGER Scode,Standard$)
2250    DIM Inp_char$[9]
2260    OUTPUT @Agt4294a;"*CLS"
2270    ON ERROR GOTO Setup_start
2280 Setup_start:   !
2290    PRINT "Set "&Standard$&"-Connection"
2300    INPUT "OK? [Y/N]",Inp_char$
2310    OFF ERROR
2320    IF UPC$(Inp_char$)="Y" THEN
2330      ON INTR Scode GOTO Meas_end
2340      ENABLE INTR Scode;2
2350      PRINT "Now measuring..."
2360      SELECT Standard$
2370        CASE "Open"
2380          OUTPUT @Agt4294a;"ECALP"
2390        CASE "Load"
2400          OUTPUT @Agt4294a;"ECALC"
2410      END SELECT
2420 Meas_wait: GOTO Meas_wait
2430 Meas_end: !
2440      PRINT Standard$&" Data Measurement Complete"
2450      RETURN 0
2460    ELSE
2470      PRINT "Program Interruption"
2480      RETURN -1
2490    END IF
2500  FNEND
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent 4294A Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      1/Mar/2002
5050   !* PROGRAM NAME: scan.bas
5060   !* REVISION:     A.01.00
5070   !*
5080   !*  Copyright (c) 1999,2002 Agilent Technologies,
5090   !*             All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
